;Filename: GetChar.s
;Part    : ADuC703x.
;Created : 14/04/2006
;Author  : Patrick Noonan (Analog Device Inc.)
;This file is in beta sampling.

;This software is supplied subject our standard software license agreement.
;A non-binding summary is as follows:
;"You may use the software in your own code at your own risk.
;" ADI inc disclaims any warranty or liability of its use".
;The full standard software license agreement is available on request and
; remains the binding agreement.

#include        <ADuC7030.inc>

; getchar==========Reads the UART data register.
; C Function prototype: int getchar(void);
; Description of Function: Waits for character from UART then returns it.
; User interface:
;   Call getchar.
;   Returns COMRX when available:
; Robustness:  Waits until character available.
; Side effects: Corrupts r3.


                RSEG CODE
                MODULE getchar
                PUBLIC getchar
                CODE32

getchar:
        mov     r3,#0xff0000            ;r3 = Z_BASE;
        orr     r3,r3,#0xff000000
GkLoop: ldr     r0,[r3,#Z_COMSTA0]      ;Loop till data ready.
        ands    r0,r0,#0x01
        beq     GkLoop
        ldrb    r0,[r3,#Z_COMRX]        ;Get COMRX.
        bx      lr                      ;return.


                 ENDMOD  getchar

                 END

